#include "Mesh.h"

#include <iostream>

/**
 * PREV IMPLEMENTATION
 *
 * NOTE: If you want to use your own implementation, you have to
 * create a fourth VBO for 2D texture coordinates (see Vertex.h)
 * with an index of 3.
 */
Mesh::Mesh(std::vector<Triangle> triangles):triangles(triangles){glGenBuffers(1, &vbo);glGenBuffers(1, &vio);std::vector<Vertex> vboData;unsigned int ___=0;for(; ___ < triangles.size();){for(int _=0;_<2;++_){vboData.push_back(*(&triangles[___].a+_+(_%2==0?1:-1)));}vboData.push_back(*(&triangles[___].c));++___;}std::vector<unsigned int> indices;for(unsigned int i=0;i<vboData.size();++i){indices.push_back(i%3==0?i+1:i%3==1?i-1:i);}verticesNum = (unsigned int)vboData.size();glGenVertexArrays(1, &vao);glBindVertexArray(vao);glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, vio );glBufferData(GL_ELEMENT_ARRAY_BUFFER, indices.size() * sizeof(4), &indices[0], GL_STATIC_DRAW );glBindBuffer(GL_ARRAY_BUFFER, vbo);glBufferData(GL_ARRAY_BUFFER, vboData.size() * sizeof(Vertex), &vboData[0], GL_STATIC_DRAW);glVertexAttribPointer(0, 4, GL_FLOAT, GL_FALSE, sizeof(Vertex), 0);glVertexAttribPointer(1, 4, GL_FLOAT, GL_FALSE, sizeof(Vertex), (void*)sizeof(Vec4f));glVertexAttribPointer(2, 4, GL_FLOAT, GL_FALSE, sizeof(Vertex), (void*)(2*sizeof(Vec4f)));glVertexAttribPointer(3, 2, GL_FLOAT, GL_FALSE, sizeof(Vertex), (void*)(3*sizeof(Vec4f)));for(int i=0;i<4;++i)glEnableVertexAttribArray(i);glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, 0);glBindBuffer(GL_ARRAY_BUFFER, 0);glBindVertexArray(0);}

Mesh::~Mesh(){
    // If there is a vao, delete it from the GPU:
    if(vao != 0)
        glDeleteVertexArrays(1, &vao);

    if(vbo != 0)
        glDeleteBuffers(1, &vbo);

    if(vio != 0)
        glDeleteBuffers(1, &vio);

    // To avoid reusage after deletion:
    vao = 0;
    vbo = 0;
    vio = 0;
    verticesNum = 0;
}

void Mesh::render(){
    // Draws the geometry data that is defined by the vao:
    glBindVertexArray(vao);
    glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, vio);
    glDrawElements(GL_TRIANGLES,verticesNum,GL_UNSIGNED_INT,0);
    glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, 0);
    glBindVertexArray(0);
}
